/**
 * 获取数据
 * @param url
 * @param objName
 * @param fun
 */
//var loadHistory=new Object();
//var isForceRefresh=false;//强制刷新
function getAjaxData(url,objName,fun,asy,isHidenWait){
	if(url.indexOf("?")>-1){
		url = url + "&";
	}else{
		url = url + "?";
	}
	if(arguments.length<3){
		$.alert("参数数量不正确");
		return false;
	}
	if(typeof objName != 'string'){
		$.alert("返回对象名不正确");
		return false;
	}
	if(!tools.isRealNull(storageUtil.getSessionId())){
		var urlIdx = url.indexOf("?");
		url = url.substring(0,urlIdx)+";jsessionid="+storageUtil.getSessionId()+url.substring(urlIdx);
	}
	var _url = "http://"+(getBasePath()+url+"objName="+objName).replace(/\/\//g,"/")+"&m="+$.now()+"&mobcom="+system+"&ver="+app_version;
	//if(loadHistory[url] && !isForceRefresh){
		//return null;
	//}
	//loadHistory[url]=true;
	asy=asy||false;
	isHidenWait=isHidenWait||false;
	if(!isHidenWait){
		showMashDiv();
	}
	var rv=false;

	$.ajax({
		url:_url,
		type:"GET",
		async:asy,
		beforeSend:function(){
			
		},
		success:function(d){
			if(d.substring(0,3)=='var'){
				eval(d.substring(4));
			}else{
				if(d.indexOf('{')>=0){
					eval(objName+"="+d);
				}else{
					eval(objName+"='"+d.replace(/'/g,"\\'")+"'");
				}
			}
			//if(!tools.isRealNull(window[objName]["jsession_id"])){
				storageUtil.setSessionId(window[objName]["jsession_id"]);//设置sessionid 为了兼容 部分android系统 不支持 cookie 导致的session丢失问题
			//}
			if(window[objName].isLogin==="0"){//未登陆 试着持续登陆
				if(storageUtil.isLUser()){
					var lu = storageUtil.getLUser();
					getAjaxData("app2/login.jsp?username=" + lu.username + "&password=" + encodeURIComponent(lu.password), "login", function(){
						var doScript=login.scripts;
						if(doScript){
							try{eval(doScript)}catch(e){}
						}
						if(login.login == '登录成功'){
							storageUtil.setLUser(login.logUser);
							return getAjaxData(url,objName,fun,asy,isHidenWait);
						}else{
							//alert(login.login);
							storageUtil.exitLUser();
							$.alert("用户名或密码错误，请重新登登录");
							if(window[objName].notLogin==="1"){//未登陆 但 不需要跳转
								return false;
							}
							changePage(wwwBaseLogin,{"transition":"slideup"});
							return;
						}
					});
				}else{//未登陆 跳转到登陆页
					if(window[objName].notLogin==="1"){//未登陆 但 不需要跳转
						return false;
					}
					changePage(wwwBaseLogin,{"transition":"slideup"});
				}
				return false;
			}else{
				//isForceRefresh=false;
				fun();
				rv=true;
				addLazyLoading();
			}
		},
		error:function(){
			$.alert("数据加载失败，请检查网络"+(isDebug?_url:""),null,"错误","确定");
		},
		dataType: "text",
		complete:function(){
			hideMaskDiv();
		}
	});
	return rv;
}
function getAjaxDataWait(url,objName,fun,asy,isHidenWait){
	asy= asy===undefined?true:asy;
	//如果方法体内，有加载下一页的方法，那么默认是显示“加载中”的层的，如果想不显示，就要自己设置isHidenWait属性
	var defaultHidenValue = !((fun+'*').indexOf('createLazyLoading(')>-1);
	isHidenWait= isHidenWait===undefined?defaultHidenValue:isHidenWait;
	if(!isHidenWait){
		showMashDiv();
	}
	window.setTimeout(function(){
		getAjaxData(url,objName,fun,asy,isHidenWait);
	}, 200);
}

/**
 * 获取参数
 * @param url
 * @param param
 * @returns
 */
function getParam(param,url){
	if(!url){
		url = window.location.href;
	}
	if (url.indexOf("?")>-1) {
		var reg = new RegExp("(^|&|\\?)" + param + "=([^&]*)(&|$)", "i");
    	var r = url.substr(url.indexOf("?")+1).match(reg);
    	if (r != null) return decodeURIComponent(r[2]);
	}
	return null;
}

/**
 * 页面切换
 * @param url 
 * @param transition 效果  fade | flip | flow | pop | slide | slidedown | slidefade | slideup | turn | none
 * @returns
 */
function changePage(url,opt){
	try{
		if(!opt){opt={}}
		var transition = opt.transition||"slideup";
		var valid=(opt.valid==="true");
		var login=(opt.login==="true")||valid;
		var reloadPage=opt.reloadPage||false;
		if(login && !storageUtil.isLUser()){
			$.mobile.changePage(wwwBaseLogin,{"transition":transition,"reloadPage":reloadPage});
		}else{
			if(valid && storageUtil.getLUser().valid=="0"){
				$.mobile.changePage(wwwBaseValid,{"transition":transition,"reloadPage":reloadPage});
			}else{
				$.mobile.changePage(url,{"transition":transition,"reloadPage":reloadPage});
			}
		}
	}catch(e){
		console.log(e);
	}
}

/**
 * 设置bean
 * @param obj
 */
function setBean(bean){
	for(var i in bean){
		var val = (bean[i] instanceof Date)?tools.formatDate(bean[i]):bean[i];
		var o = $("[id="+i+"]");
		var sbm = o.attr("sbm");
		if(sbm!=null && sbm.length>0){
			var ms=sbm.split(".");
			var wm = window;
			for(var n=0;n<ms.length;n++){
				wm = wm[ms[n]];
				if(!wm){
					showErrorTip("sbm参数不正确，方法"+sbm+"不存在");
					return;
				}
			}
			val = wm(val);
		}
		if(o.length>0 && o.get(0).tagName.toLowerCase()=="input"){
			o.val(val);
		}else{
			o.html(val);
		}
	}
}

$(document).on('pagecreate',function(){
	$(".return_btn[href^='javascript:void(0)']").on("click", function(){
		window.history.go(-1);
	}).attr('href','javascript:;');
	$('#phoneDivForTra').on("click",function(obj){
		showPhoneDivMain($(this).attr('num'));
	}).attr("id","phoneDivForTra_over");
});

$(document).on('click',"a[data-login='true']",function(){
	if(!storageUtil.isLUser()){
		changePage(wwwBaseLogin,{"login":"true"});
		return false;
	}
});

var closePopMethod;
/**
 * 弹出提示框
 * @param {} v // 提示的文字
 * @param {} obj //提示文字显示时间 毫秒
 */
$.dialogMess = function(v, obj) {
	var d = new Object();
	if (typeof (obj) == 'number') {
		d.time = obj;
	}else if(obj){
		d = obj;
	}
	if (!d.time) {
		d.time = 3000;
	}
	var page = $.mobile.activePage;
	var id = page.attr("id") + "_pop";
	if ($('#' + id).length <= 0) {
		page.append('<div data-role="popup" id="' + id + '" data-transition="fade" class="hint" style="z-index:999999;"><div>提示信息</div><p></p></div>');
		$('#' + id).popup({});//初始化
	}
	$('#' + id).one({
      popupafterclose: function() {
    		if(d.callBack){
	  			d.callBack();
	  		}
        }
    });
	$('#' + id).children('p').text(v);
	$('#' + id).popup("open");//,{y:10} 配置项
	clearTimeout(closePopMethod);
	closePopMethod=setTimeout(function() {
		$('#' + id).popup("close");
	}, d.time);
}
$.alert=function(mess,fun,title,buttonName){
	fun = fun || function(){};
	title = title || "提示";
	buttonName=buttonName||"确定";
	try {
		navigator.notification.alert(mess, // message
		fun,
		title,// title
		buttonName// buttonName
		);
	} catch (e) {
		alert(mess);
		fun();
	}
}
function onBackKeyDown() {
	if(getParam("push")=="true"){
		onConfirm(1);
		return;
	}
	// 显示确认对话框
	navigator.notification.confirm(
		'是否要退出乾包',  // 显示信息
		onConfirm,              // 按下按钮后触发的回调函数，返回按下按钮的索引
		'退出程序',            // 标题
		'确认,取消'          // 按钮标签
	);
}
// 处理确认对话框返回的结果
function onConfirm(button) {
	if(button == 1){
		navigator.app.exitApp();
	}
}
//后台转前台
function onResume(n) {
	if(getParam("push")=="true"){
		changePage(wwwBasePath+"index.html");
		return;
	}
	if(n==-1){
		if(!storageUtil.isWelcome()){
			storageUtil.isWelcome(true);
			changePage(wwwBasePath+"welcome.html");
		}else{
			changePage(wwwBasePath+"ind.html");
		}
		return;
	}
	if(window.isPlug){
		window.isPlug=false;
		return;
	}
	/*if(storageUtil.getHandPwd()!=null){
		changePage(wwwBasePath+"user/loginByHands.html",{"transition":"slideup"});
	}*/
	cacheLogin();
}
//后退按钮
function onDeviceReady() {
	if(window && window.device && window.device.platform.toLowerCase()=="ios"){
		system = "ios";
	}
	document.addEventListener("backbutton", onBackKeyDown, false);
	document.addEventListener("resume", onResume, false);
	navigator.splashscreen.hide();
	/*if(system=="android"){
		fastgoPushNotification.init("YBe6tmSFgGV0dGYoi7QVrrqk");
	}*/
	setTimeout("setBaiduPush(0)", 5000);
	setTimeout("autoUpdNewSmallVersion()", 5000);
	//onResume(-1);
}

/**
 * 持续登陆
 */
function cacheLogin(){
	if(storageUtil.isLUser()){
		getAjaxData("app2/login.jsp?username=" + storageUtil.getLUser().username + "&password=" + encodeURIComponent(storageUtil.getLUser().password), "login", function(){
			if(login.login == '登录成功'){
				if(login.logUser){
					storageUtil.setLUser(login.logUser);
				}
			}else{
				storageUtil.exitLUser();
			}
		},true,true);
	}
}

/**
 * 根据用户ip地址设置用户地址
 * @param ip
 */
function setArea(ip,fun){
	if(typeof(ip)=='function'){
		fun = ip;
		ip = null;
	}
	$.getScript("http://int.dpool.sina.com.cn/iplookup/iplookup.php?format=js"+(ip==null?"":"&ip="+ip),function(e){
		fun(remote_ip_info);
	});
}
/**
 * 获取IP地址
 */
function setLocalIp(){
	var url = 'http://chaxun.1616.net/s.php?type=ip&output=json&callback=?&_='+Math.random(); 
   $.getJSON(url, function(data){
	   $.alert(date.Ip);
    });
}
window.doLazy = {};
window.addLazy = function(lazyObj){
	if(lazyObj){
		if(window.doLazy[lazyObj.id]){
			window.doLazy[lazyObj.id].addRunValue(lazyObj.baselist);
		}else{
			window.doLazy[lazyObj.id]=lazyObj;
		}
	}
}
$(document).delegate(window,"scroll",function(){
	for(var key in window.doLazy){
		window.doLazy[key].appRun();
	}
});
function lazyObj(os,runfun,t){
	this.id = 'a'+new Date().getTime();
	this.time = t || 500;
	this.baselist = os || [];
	this.isAdding = false;
	this.isRun = true;
	this.runList = new Array();
	this.addRunValue = function(arr){
		for(var i=0;i<arr.length;i++){
			this.runList.push(arr[i]);
		}
		if(!this.isRun){
			this.run();
		}
	}
	this.appRun = function(){
		if (document.documentElement && this.baselist && !this.isAdding) {
			this.isAdding = true;
			for(var i=0;i<this.baselist.length;i++){
				var o = $(this.baselist[i]);
				var objTop = o.offset().top;
				var top = $(document).scrollTop();
				var winH = $(window).height();
				var isVisible = o.is(":visible") || o.parent().is(":visible");
				
				if ((winH + top > objTop) && top<=(objTop+o.height()) && isVisible) {
					this.baselist.splice(i,1);
					i--;
					this.runList.push(o);
					//this.run();//这里设置执行，且 关闭 window.setTimeout("window.doLazy."+this.id+".run()", this.time); 语句，可以直接不用等待，进显示语句即加载
				}
			}
			this.isAdding = false;
		}
	};
	this.run = function(){
		var o = this.runList.shift();
		if(o){
			runfun(o);
		}
		if(this.baselist.length>0 || o || this.runList.length>0){
			window.setTimeout("window.doLazy."+this.id+".run()", this.time);
		}else{
			isRun = false;
		}
	};
	this.run();
	this.appRun();
}
function addLazyLoading(){
	var o=$("[data-lazy-loading='true']");
	$(o).each(function(v){
		$(this).attr("data-lazy-loading","false");
	});
	window.addLazy(new lazyObj(o,function(v){
		var s=$(v).attr("data-lazy-method");
		eval(s);
		$(v).remove();
	}),200);
}
function createLazyLoading(method){
	method=method.replace(/\[|\]/g,"\"");
	return "<div style='height:1px;width:100%;float:left;' data-lazy-method='"+method+"' data-lazy-loading='true'></div>";
}
var ajaxCloseDivTime;
var isShowWaitDiv=false;
function showMashDiv(){//显示遮罩层
	//console.log(showMashDiv.caller,arguments.callee,arguments.callee.caller);
	window.clearTimeout(ajaxCloseDivTime);
	isShowWaitDiv=true;
	$("#all_Ajax_Back").show();
	$("#loadingDiv").show();
}
function hideMaskDiv(){//隐藏遮罩层
	window.clearTimeout(ajaxCloseDivTime);
	ajaxCloseDivTime=setTimeout(function(){
		$("#all_Ajax_Back").hide();
		$("#loadingDiv").hide();
		isShowWaitDiv=false;
	},200);
}
/*
jQuery.ajaxSetup({
	beforeSend:function(){
		//showMashDiv();
	},
	complete:function(){
		hideMaskDiv();
	}
});
*/
//获取推送相关信息
var _baiduPush={};
function setBaiduPush(n){
	if(!storageUtil.isLUser()){
		window.setTimeout("setBaiduPush(0)",3000);
		return;
	}
	
	n=n||0;
	n++;
	if(system=='ios'){
		MyIOSPlugin.getBaiduPushInfo([],function(v){
			eval("_baiduPush="+v);
			var bool = savePashInfo(_baiduPush.appId,_baiduPush.channelId,_baiduPush.userId,window.device.version,window.device.model,window.device.manufacturer);
			if(!bool){
				if(n<=10){
					window.setTimeout("setBaiduPush("+n+")",2000);
				}
			}
		},function(v){
			if(n<=10){
				window.setTimeout("setBaiduPush("+n+")",2000);
			}
		});
	}else{
		_baiduPush={};
		_baiduPush.appId=fastgoPushNotification.appId;
		_baiduPush.channelId=fastgoPushNotification.channelId;
		_baiduPush.userId=fastgoPushNotification.userId;
		if(_baiduPush.appId && _baiduPush.channelId && _baiduPush.userId){
			var bool = savePashInfo(_baiduPush.appId,_baiduPush.channelId,_baiduPush.userId,window.device.version,window.device.model,window.device.manufacturer);
			if(!bool){
				if(n<=10){
					window.setTimeout("setBaiduPush("+n+")",2000);
				}
			}
		}else{
			if(n<=10){
				window.setTimeout("setBaiduPush("+n+")",2000);
			}
		}
	}
}

function savePashInfo(appId,channelId,userId,version,model,manufacturer){
	if(tools.isRealNull(appId) || tools.isRealNull(channelId) || tools.isRealNull(userId)){
		return false;
	}
	version = encodeURIComponent(version || '');//操作系统版本号
	model = encodeURIComponent(model || '');//手机型号
	manufacturer = encodeURIComponent(manufacturer || '');//生产商
	getAjaxData("app/user/setUserPashInfo.jsp?system="+system+"&appId="+appId+"&channelId="+channelId+"&userId="+userId+"&version="+version+"&model="+model+"&manufacturer="+manufacturer,"_baidu_pashInfo",function(d){},true,true);
	return true;
}

$(function(){
	new FastClick(document.body);
	/*$demo.on('touchend',function(e){//改变了事件名称，tap是在body上才被触发，而touchend是原生的事件，在dom本身上就会被捕获触发
		$demo.hide()
		e.preventDefault();//阻止“默认行为”
	})*/
});

//自动更新
function autoUpdNewSmallVersion(isAlert){
	var upd_ver = __updateVersion();
	getAjaxDataWait("app/user/upload_js.jsp?upd_ver="+upd_ver,"__verUpd",function(){
		if(__verUpd.upd_ver){//设置小更新版本号，且至少有小更新版本号，才有需要更新的内容
			var updVer = __verUpd.upd_ver;
			var updVal = __verUpd.updVal;
			for(var key in updVal){
				var xmlHttp = getxmlHttp();
				// 采用异步加载
				xmlHttp.open("GET", getBaseRootPath()+updVal[key], true);
				// 发送同步请求，如果浏览器为Chrome或Opera，必须发布后才能运行，不然会报错
				xmlHttp.onreadystatechange=function(){
					if(xmlHttp.readyState===4){
						// 0为访问的本地，200到300代表访问服务器成功，304代表没做修改访问的是缓存
						if ((xmlHttp.status >= 200 && xmlHttp.status < 300) || xmlHttp.status == 0 || xmlHttp.status == 304){
							__saveLocalStorage(key,xmlHttp.responseText,app_version);
						}
					}
				}
				xmlHttp.send();
			}
			__updateVersion(updVer);
//			if(isAlert){
//				baiduVideoTools('say',['小更新完成']);
//			}
		}
	});
}
//autoUpdNewSmallVersion();