/**
 * calc.html js 
 */
$(document).on('pagecreate','#calc',function(){
	var nav = $('#calc #nav'); //获取导航所在节点
	nav.sel({
		LAZY : '0',
		CUSTOM : '1',
		PACK_178 : '2',
		LAZY_ : '_l',
		CUSTOM_ : '_c',
		PACK_178_ : '_p',
		interest : 'calc #interest', //利息
		account : 'calc #total', //收益总额
		details : 'calc #interestDetails', //显示详细收款记录按钮
		EQUALS_EAR : 0, //收益方式 等额本息
		RETURN_EAR : 1, //收益方式 收益返还
		EQUALS_178_EAR : 2, //收益方式 赚乾包 等额本息(原自选包等额本息)
		Rate_lazy_low: 6, //零乾包 年利率 下限
		Rate_lazy_up: 24, //零乾包 年利率 上限
		Rate_cp_low: 9, //定制&赚乾包 年利率 下限
		Rate_cp_up: 16, //定制&赚乾包 年利率 上限
		Rate_pack178_low: 6, //赚乾包 年利率 下限
		Rate_pack178_up: 24, //赚乾包 年利率 上限
		on:'tabBtn3_1 ui-link', //被选中的
		over:'tabBtn3_2 ui-link', //带竖线的
		blank:'tabBtn3_3 ui-link', //不带竖线的
	});
	
	var param = getParam('param') || 0; //获取计算什么类型包参数 【0.零乾包 1.定制包 2.赚乾包】
	$(nav.find('a')[1]).trigger('click');
	
	var arrNums = $('#calc [id ^="num_"]'); //当前数值节点
	arrNums.valid({
		LAZY : 'l',
		CUSTOM : 'c',
		PACK_178 : 'p',
		interest : 'calc #interest', //利息
		account : 'calc #total', //收益总额
		details : 'calc #interestDetails', //显示详细收款记录按钮
		EQUALS_EAR : 0, //收益方式 等额本息
		RETURN_EAR : 1, //收益方式 收益返还
		EQUALS_178_EAR : 2, //收益方式 赚乾包 等额本息(原自选包等额本息)
		Rate_lazy_low: 6, //零乾包 年利率 下限
		Rate_lazy_up: 24, //零乾包 年利率 上限
		Rate_cp_low: 9, //定制&赚乾包 年利率 下限
		Rate_cp_up: 16, //定制&赚乾包 年利率 上限
		Rate_pack178_low: 6, //赚乾包 年利率 下限
		Rate_pack178_up: 24 //赚乾包 年利率 上限
	});
	arrNums = [];
	changeUI(0);
});

/**
 * 导航切换 以及UI修改
 */
$.fn.sel = function(opt) {
	opt = $.extend({
		LAZY : '0',
		CUSTOM : '1',
		PACK_178 : '2',
		LAZY_ : '_l',
		CUSTOM_ : '_c',
		PACK_178_ : '_p',
		interest : 'calc #interest', //利息
		account : 'calc #total', //收益总额
		details : 'calc #interestDetails', //显示详细收款记录按钮
		EQUALS_EAR : 0, //收益方式 等额本息
		RETURN_EAR : 1, //收益方式 收益返还
		EQUALS_178_EAR : 2, //收益方式 赚乾包 等额本息(原自选包等额本息)
		Rate_lazy_low: 6, //零乾包 年利率 下限
		Rate_lazy_up: 24, //零乾包 年利率 上限
		Rate_cp_low: 9, //定制&赚乾包 年利率 下限
		Rate_cp_up: 16, //定制&赚乾包 年利率 上限
		Rate_pack178_low: 6, //赚乾包 年利率 下限
		Rate_pack178_up: 24, //赚乾包 年利率 上限
		on:'tabBtn3_2 ui-link', //被选中的
		over:'tabBtn3_2 ui-link', //带竖线的
		blank:'tabBtn3_3 ui-link', //不带竖线的
    },opt || {});
	var arrNavEles = $(this).find('a');
	/*arrNavEles.on('click',function(){
    	if($(this).prop('class') == opt.on){
    		return false;
    	}else{
    		arrNavEles.removeClass();
    		$(this).addClass(opt.on);
    	}
    	var index = 1;
    	var arrCss = new Array();
    	arrNavEles.each(function(i){
    		if($(arrNavEles[i]).prop('class') == opt.on){
				arrCss = [i == opt.LAZY ? opt.on : opt.over, i == opt.LAZY ? opt.over : i == opt.CUSTOM ? opt.on : opt.blank, i == opt.PACK_178 ? opt.on : opt.blank];
				index = i;
    		}
    		$(arrNavEles[i]).removeClass();
    	});
    	for(var i=0;i<arrCss.length;i++){
    		$(arrNavEles[i]).addClass(arrCss[i]);
		}
    	arrCss = [];
    	changeUI(1);
    });*/
	changeUI = function(index){
		initNums_0();
		
		/**
		 * 解绑 防止多次绑定事件
		 */
		$('#calc [id ^= "earnMtd_"]').unbind('click');
		
		$('#calc [id ="earnMtd_return"]').remove();
		var arrNums = $('#calc [id ^="num_"]');
		var arrIdH = new Array();
		
		arrNums.each(function(i){
			var strs = arrNums[i].id.split('_');
			arrIdH.push(strs[0]+'_'+strs[1]);
			$(arrNums[i]).val('');
		});
		
		arrNums.prop('id','');
		var idTail = index == opt.LAZY ? opt.LAZY_ : index == opt.CUSTOM ? opt.CUSTOM_ : opt.PACK_178_;
		
		arrPH = new Array(); //placeholder属性的修改
		var ph_money = index == opt.LAZY ? '50元起投' : index == opt.CUSTOM ? '请输入5000元的整数倍' : '50元起投';
		var ph_rate = index == opt.LAZY ? opt.Rate_lazy_low +'~'+ opt.Rate_lazy_up : index == opt.CUSTOM  ? opt.Rate_cp_low + '~' + opt.Rate_cp_up : opt.Rate_pack178_low + '~' + opt.Rate_pack178_up;
	
		
		arrPH.push(ph_money);
		arrPH.push(ph_rate);
		$(arrNums[0]).prop('placeholder',arrPH[0]);
		$(arrNums[2]).prop('placeholder',arrPH[1]);
		arrPH = [];
		
		arrNums.each(function(i){
			$(arrNums[i]).prop('id',arrIdH[i]+idTail);
		});
		arrIdH = [];
		
		var earnMtd = 0;  //收益方式 0.收益复投 1.收益返还
		if(index == opt.CUSTOM){
			$('#calc #earnMtd_equals').after('<span class="inputText" id="earnMtd_return">收益返还</span>');
		}
		
		$('#calc [id ^= "earnMtd_"]').removeClass('zngy-calc-bold');
		$('#calc #earnMtd_equals').addClass('zngy-calc-bold');
		
		/**
		 * 点选 [收益方式] 的相关逻辑
		 */
		$('#calc [id ^= "earnMtd_"]').bind('click',function(){
			if($(this).prop('class').indexOf('zngy-calc-bold') > -1){
				return false;
			}
			initNums_0();
			var arrNums = $('#calc [id ^="num_"]');
			arrNums.each(function(i){
				$(arrNums[i]).val('');
			});
			arrNums = [];
			
			$('#calc #interestDetails').hide();
			$('#calc [id ^= "earnMtd_"]').removeClass('zngy-calc-bold');
			$(this).addClass('zngy-calc-bold');
			if(this.id.split('_')[1] == 'return'){
				earnMtd = opt.RETURN_EAR; //收益返还
			}else{
				earnMtd = opt.EQUALS_EAR; //收益复投
			}
			
			var arrNums_ = $('#calc [id ^="num_"]');
			var carr = $('<input type="hidden" value="'+ earnMtd +'"/>');
			arrNums_.push(carr);
			arrNums_.valid({});
			arrNums = [];
			
		});
		arrNums.valid({
			LAZY : 'l',
			CUSTOM : 'c',
			PACK_178 : 'p',
			interest : 'calc #interest',
			account : 'calc #total',
			details : 'calc #interestDetails',
			EQUALS_EAR : 0,
			RETURN_EAR : 1,
			EQUALS_178_EAR : 2,
			Rate_lazy_low: 6,
			Rate_lazy_up: 24,
			Rate_cp_low: 9,
			Rate_cp_up: 16,
			Rate_pack178_low: 6, 
			Rate_pack178_up: 24
		});
		arrNums = [];
	};
	
	/**
	 * 初始化页面上的计算结果 当导航发生变化
	 */
	initNums_0 = function(){
		$('#'+opt.details).hide();
		$('#'+ opt.interest).html('0.00');
		$('#'+ opt.account).html('0.00');
	};
};

/**
 * 输入校验 以及判断计算
 */
$.fn.valid = function(opt) {
	opt = $.extend({
		LAZY : 'l',
		CUSTOM : 'c',
		PACK_178 : 'p',
		interest : 'calc #interest', //利息
		account : 'calc #total', //收益总额
		details : 'calc #interestDetails', //显示详细收款记录按钮
		EQUALS_EAR : 0, //收益方式 等额本息
		RETURN_EAR : 1, //收益方式 收益返还
		EQUALS_178_EAR : 2, //收益方式 赚乾包 等额本息(原自选包等额本息)
		Rate_lazy_low: 6, //零乾包 年利率 下限
		Rate_lazy_up: 24, //零乾包 年利率 上限
		Rate_cp_low: 9, //定制&赚乾包 年利率 下限
		Rate_cp_up: 16, //定制&赚乾包 年利率 上限
		Rate_pack178_low: 6, //赚乾包 年利率 下限
		Rate_pack178_up: 24 //赚乾包 年利率 上限
    },opt || {});
	
	/**
	 * 解绑 防止多次绑定事件
	 */
	$(this).unbind('keyup').unbind('focus');
	$('#'+opt.details).unbind('click');
	
	var arr = $.makeArray( $(this) );
	var type = $(arr[0]).prop('id').split('_')[2];
	
	var money =$(arr[0]);
	var month = $(arr[1]);
	var rate = $(arr[2]);
	var earnMtd = $(arr[3]).val() || 0;
	
	/**
	 * 数值的校验 当键盘输入的时候
	 */
	var money_val;
	var month_val;
	var rate_val;
	$(money).bind('keyup',function(){ //投资金额
		initNums();
		var  bool = true;
		var val = $(this).val();
		if(val == ''){
			bool = false;
			return;
		}
		if(!valid.isInteger($(this).val()) && $(this).val() != ''){
			$(this).val(money_val);
		}
		money_val = $(this).val();
		
		if(type == opt.LAZY){
			if($(this).val() < 50){
				bool = false;
				return;
			}
			if($(this).val().length > 1 && $(this).val()<50){
				showErrDom($(this),'50元起投');
				bool = false;
				$(this).blur();
				return;
			}
		}else if(type == opt.CUSTOM){
			if($(this).val() < 5000){
				bool = false;
				return;
			}
			if($(this).val().length > 3 && $(this).val()%5000 != 0){
				showErrDom($(this),'请输入5000元的整数倍');
				bool = false;
				$(this).blur();
				return;
			}
		}else if(type == opt.PACK_178){
			if($(this).val()<50){
				bool = false;
				return;
			}
			if($(this).val().length > 1 && $(this).val()<50){
				showErrDom($(this),'50元起投');
				bool = false;
				$(this).blur();
				return;
			}
		}
		judgeCal(bool,$(money).val(),$(month).val(),$(rate).val(),earnMtd,type);
	}).bind('focus',function(){
		if(!valid.isInteger($(this).val())){
			$(this).val('');
			bool = false;
			return;
		}
	});
	
	$(month).bind('keyup',function(){ //投资期限(月)
		initNums();
		var  bool = true;
		var val = $(this).val();
		if(val == ''){
			bool = false;
			return;
		}
		if((!valid.isInteger($(this).val()) && $(this).val() != '') || $(this).val().length > 2){
			$(this).val(month_val);
		}
		month_val = $(this).val();
		judgeCal(bool,$(money).val(),$(month).val(),$(rate).val(),earnMtd,type);
	});
	
	$(rate).bind('keyup',function(){ //年化收益率
		initNums();
		var bool = true;
		var val = $(this).val();
		if(val == ''){
			bool = false;
			return;
		}
		var reg = /^\d+(?:\.\d{0,1})?$/;
		var len = $(this).val().length;
		if(!reg.test($(this).val()) && $(this).val() || len > 4){
			$(this).val(rate_val);
		}
		rate_val = $(this).val();
		if(type == opt.LAZY) {
			if($(this).val() < opt.Rate_lazy_low){
				bool = false;
				return;
			}
			if($(this).val().length > 1 &&  $(this).val() > opt.Rate_lazy_up){
				showErrDom($(this),opt.Rate_lazy_low + '~'+ opt.Rate_lazy_up);
				bool = false;
				$(this).blur();
				return;
			}
		} else if(type == opt.CUSTOM) {
			if($(this).val() < opt.Rate_cp_low){
				bool = false;
				return;
			}
			if($(this).val().length >  1 && $(this).val() > opt.Rate_cp_up){
				showErrDom($(this),opt.Rate_cp_low + '~'+ opt.Rate_cp_up);
				bool = false;
				$(this).blur();
				return;
			}
		} else {
			if($(this).val() < opt.Rate_pack178_low){
				bool = false;
				return;
			}
			if($(this).val().length > 1 && $(this).val() > opt.Rate_pack178_up){
				showErrDom($(this),opt.Rate_pack178_low + '~'+ opt.Rate_pack178_up);
				bool = false;
				$(this).blur();
				return;
			}
		}
		judgeCal(bool,$(money).val(),$(month).val(),$(rate).val(),earnMtd,type);
	}).bind('focus',function(){
		var reg = /^\d+(?:\.\d{0,1})?$/;
		var len = $(this).val().length;
		if(!reg.test($(this).val()) && $(this).val() || len > 4){
			$(this).val('');
			bool = false;
			return;
		}
	});
	
	/**
	 * 点击显示收益明细的逻辑
	 */
	$('#'+opt.details).bind('click',function(){
		var arrNums = $('#calc [id ^="num_"]');
		var money = $(arrNums[0]).val();
		var month = $(arrNums[1]).val();
		var rate = $(arrNums[2]).val();
		var boldType = $('#calc .zngy-calc-bold').prop('id').split('_')[1];//获取收益类型
		var earnMtd =  type == opt.PACK_178 ? opt.EQUALS_178_EAR : boldType == 'return' ? opt.RETURN_EAR : opt.EQUALS_EAR;
		
		if(money != '' && month != '' && rate != ''){
			changePage(wwwBasePath +'calc/interestDetails.html?money='+money+'&month='+month+'&rate='+rate+'&earnMtd='+earnMtd);
		}else{
			$.alert('nums is error');
		}
	});
	
	/**
	 * 提示相关错误【闪烁3次】
	 */
	showErrDom = function($o,mess){
		$o.val(mess);
		shake($o,'zngy-calc-red',3);
	};
	shake = function(ele,cls,times){ //闪烁提示错误
        var i = 0,t= false ,o =ele.prop("class")+" ",c ="",times=times||2;
        if(t) return;
        t= setInterval(function(){
            i++;
            c = i%2 ? o+cls : o;
            ele.prop("class",c);
            if(i==2*times){
                clearInterval(t);
                ele.removeClass(cls);
                }
            },200);
	};
	
	/**
	 * 初始化页面显示的计算结果 当不满足计算条件的时候
	 */
	initNums = function(){
		$('#'+opt.details).hide();
		$('#'+ opt.interest).html('--.--');
		$('#'+ opt.account).html('--.--');
	};
	
	/**
	 * 计算的判断 是否可以进行计算
	 */
	judgeCal = function(bool,money, month, rate, mtd, type){
		if(bool && money != '' && month != '' && rate != ''){
			var rateMonth = parseFloat(rate*10.0/1000/12) *1.0;  //月利率
			if(type == opt.LAZY){ //零乾包
				//console.log('lazy');
				getLazyAvg(money*1.0, month*1.0, rateMonth);
			}else{
				if(type == opt.CUSTOM){ //定制
					if(mtd == opt.EQUALS_EAR){
						//console.log('cus -fl_');
						getCustomFL(money*1.0, month*1.0, rateMonth);
					}else{
						//console.log('cus -dl_');
						getMonthResult(money*1.0, month*1.0, rateMonth);
					}
				} else { //178
					//console.log('178 -debx_');
					getequles(money*1.0, month*1.0, rateMonth);
				}
				$('#'+opt.details).show();
			}
		}
	};
	
	/**
	 * 各类计算收益总额的公式 以及显示计算结果
	 */
	getequles = function(finMoney, finDate, finRateMonth){ //获取赚乾包 等额本息计算结果(原自选包 等额本息计算公式)
		// 总收益计算公式: [ {投资总金额*月利率*[(1+月利率)^期数]}/[(1+月利率)^期数－1] ] *  期数 
		var account = getFen(finMoney) * finRateMonth * ((Math.pow((finRateMonth + 1) , finDate))/(Math.pow((finRateMonth + 1) , (finDate)) -1 )) * finDate;
		var interest = account - getFen(finMoney);
		showResult(interest, account);
	};
	getLazyAvg = function(finMoney, finDate, finRateMonth){//获取零乾包平均收益
		//总利息=（本金*(1+ 月利率 *月数)-本金）
		var interest = (getFen(finMoney) * (1 + finRateMonth * finDate) - getFen(finMoney));
		var account = getFen(finMoney) + interest;
		showResult(interest, account);
	};
	getCustomFL = function(finMoney, finDate, finRateMonth){ //获取定制标复利 \零乾包收益复投 计算结果  
		//总收益计算公式: 投资金额*((1+月利率)^期数) 
		var account = getFen(finMoney) * (Math.pow((finRateMonth + 1) , finDate));
		var interest = account - getFen(finMoney);   
		showResult(interest, account);
	};
	getMonthResult = function(finMoney, finDate, finRateMonth){ // 获取单利/每月还息计算结果	
		//总收益计算公式：投资总金额 *  投资期数 *  月利率 
		var interest = getFen(finMoney) * finDate * finRateMonth;
		var account = interest + getFen(finMoney);
		showResult(interest, account); 
	};
	showResult = function(interest, account){
		$('#'+opt.interest).html(tools.formatNumber(formatNum(getYuan(interest))));
		$('#'+opt.account).html(tools.formatNumber(formatNum(getYuan(account))));
	};
	
	/**
	 * 数值处理方法
	 */
	getYuan = function(val){
		return val/100 * 1.0;
	};
	getFen = function(val){
		return val*100;
	};
	formatNum = function(val){
		if(String(val).indexOf(".") == -1){
			return val + ".00";  
		}else{
			if(String(val).split(".")[1].length > 2){
				return String(val).substring(0, String(val).indexOf(".") + 3);  
			}else{
				return String(val).substring(0, String(val).indexOf(".") + 2); 
			}
		}  
	};
};