/**
 * joinPack178.html js 
 *	getAjaxData('app2/.jsp','obj',function(){});
 */
$(document).on('pageshow','#joinPack178',function(){
	var bid = getParam('id'); //标ID
	var yqm = getParam('yqm') || ''; //获取页面传递过来的邀请码
	var BTN = $('#joinPack178 #btn'); // 加入按钮
	var REMAIN = $('#joinPack178 #remainM'); //页面显示的标余额
	var MONEY = $('#joinPack178 #joinM'); //加入金额提示框
	var AGREE_A = $('#joinPack178 #pack178_agree_a'); //点击同意赚乾包加入协议
	var AGREE = $('#joinPack178 #pack178_agree'); //点击同意赚乾包加入协议
	
	/*var AGREE2_A = $('#joinPack178 #pack178_agree2_a'); //点击同意每月返还本息自动创建零乾包投资
	var AGREE2 = $('#joinPack178 #pack178_agree2'); //点击同意每月返还本息自动创建零乾包投资
*/	
	changeBtn(BTN);
	getAjaxDataWait('app2/package178/joinPack178.jsp?id=' + bid, 'obj', function(){
		var biaoRem = obj.biaoRem; //当前标剩余金额
		var remain = obj.remain; //当前投资人可投标最大金额
		var theLast = obj.theLast != '' && obj.theLast == 'theLast'; //是否最后一个投标人
		
		if(theLast){
			MONEY.prop('readonly',true).val(remain);
			BTN.removeClass().addClass('button_a');
		} else {
			MONEY.prop('placeholder', '50~' + remain );
		}
		REMAIN.html(theLast ? 0 : tools.formatNumber(biaoRem));
		if(obj.biaoSchedule){//标进度为100时文本框不可输入
			MONEY.prop('placeholder','');
			MONEY.attr("readonly",true);
		}
		var val_;
		MONEY.on('keyup blur',function(){
			if(!valid.isNumberPointTwo($(this).val()) && $(this).val() != '' || $(this).val() > parseFloat(remain +0.01)){
				$(this).val(val_);
			}
			val_ = $(this).val();
			var $reward = $('#joinPack178 [id^="reward_"]');
			var bool = isChecked(AGREE) && val_ >= 50 && val_ <= remain;
			REMAIN.html(tools.formatNumber((biaoRem - val_) < 0 ? 0 : (biaoRem - val_).toFixed(2))); //页面显示的标余额随输入联动
			changeBtn(bool,BTN); //改变加入按钮
		});
		
		AGREE.on('change',function(){ //点选同意赚乾包加入协议
			var $reward = $('#joinPack178 [id^="reward_"]');
			changeChk(AGREE_A, AGREE);
			changeBtn(isChecked(AGREE) && chkForm(remain, MONEY.val(), AGREE, AGREE_A,$reward),BTN); //改变加入按钮
		});
		
		var isagree2 = 0;
		BTN.on('click',function(){ //点击投资按钮
			if(storageUtil.getLUser().valid == 0){
				changePage("../mine/mineAuthentication.html",{"login":"true"})
				return;
			}
			if($(this).prop('class').indexOf('button_ab') > -1){
				return false;
			}
			if(remain - MONEY.val() < 50 && remain != MONEY.val()){
				showErrorTip('抱歉，此金额会导致下一个人无法参投，请重填');
				return false;
			}
			//如果输入的金额以小数点结尾，去掉小数点
			if(MONEY.val().charAt(MONEY.val().length-1) == "."){
				MONEY.val(MONEY.val().substr(0,MONEY.val().length-1));
			}
			var $reward = $('#joinPack178 [id^="reward_"]');
			if(isChecked(AGREE) && chkForm(remain, MONEY.val(), AGREE, AGREE_A,$reward)) {
				isagree2 = 1;
				//cbPage bid orderMoney invCode
				var params = "cbPage=joinPack178_app&bid=" + bid + '&orderMoney=' + MONEY.val() + '&invCode=' + yqm + '&isagree2=' + isagree2+"&rewardType=3";
				changePage('../user/pay.html?' + params); //跳转到支付页面 去支付
			}
		});
		AGREE_A.next().on('click',function(){ //点击查看赚乾包加入协议
			changePage('../xyht/178btbxyfb.html');
		});
	});
});

$(document).on('pagecreate','#joinPack178',function(){
	var BTN = $('#joinPack178 #btn'); // 加入按钮
	var AGREE = $('#joinPack178 #pack178_agree'); //点击同意赚乾包加入协议
	$('#joinPack178 #joinM').on('blur',function(){//获取奖励信息
		var money = this.value;
		if(money<=0){
			$('#joinPack178 #reward').hide();
			return false;
		} 
		getRewardInfo(money);
		$('#joinPack178 #reward').show();
		changeBtn(isChecked(AGREE) && money>=50,BTN);
	});
});


/**
 * 修改按钮 [样式 可点击:button_a / 不可点击:+button_ab]
 */
function changeBtn(bool,$btn){
	if(typeof(bool) == 'object'){
		$btn = bool;
		bool = null;
	}
	bool = bool || false;
	$btn.removeClass().addClass(bool ? 'button_a':'button_a button_ab');
}

/**
 * 修改checkbox [样式 选中:lqcheck lqcheckb 未选:lqcheck]
 * @param bool
 */
function changeChk($oa, $o){
	$oa.removeClass().addClass(isChecked($o) ? 'lqcheck lqcheckb' : 'lqcheck');
}
function isChecked($o){
	return $o.get(0).checked;
}

/**
 * 提交表单校验
 * @param rmainM 标余额
 * @param joinM 加入金额
 * @param $o 同意赚乾包协议CheckBox
 * @param $oa 同意赚乾包协议 a
 * @returns {Boolean}
 */
function chkForm(remainM, joinM, $o, $oa,$r){
	if(!joinM || joinM.replace(/\s+/g, "") == ''){
		showErrorTip('投标金额不能为空');
		return false;
	}
	if(joinM < 50){
		showErrorTip('50元起投');
		return false;
	}
	if(joinM > remainM){
		showErrorTip('投标金额大于标余额');
		return false;
	}
	if(!isChecked($o)){
		showErrorTip('请同意赚乾包加入协议');
		return false;
	}
	return true;
}
/**
 * 根据参投金额，获取奖励信息
 * @param joinMoney
 */
function getRewardInfo(joinMoney){
	getAjaxDataWait("app2/package178/getRewardInfo.jsp?money="+joinMoney, "reward", function(){
		if(reward.reward!="error"){ 
		var html = '<div class="youhuiquan">'+
							'<div class="qixian">加息券<br><span>请在'+reward.validTime+'天内使用</span></div>'+
							'<div class="jine"><p>'+reward.hikeTitile+'</p><span>'+reward.typeUse+'</span></div>'+
							'<div class="clearfix"></div>'+
					  '</div>'+
					  '<div class="youhuiquan">'+
							'<div class="qixian">赚乾包购物券<br><span>请在'+reward.svalidTime+'天内使用</span></div>'+
							'<div class="jine"><p>￥'+reward.rmoney+'</p><span>满'+reward.shopMoney+'元使用</span></div>'+
							'<div class="clearfix"></div>'+
					  '</div>'
  		$("#joinPack178 #reward #newreward").empty().append(html);
		}
	});
}