$(document).on('pageshow','#newShopIndex',function(){ 
	//轮播banner
	if ($("#newShopIndex .bannerimg2 ul li").length<1){
		getBanner("newshop_banner_div", 22);
	}
});
$(document).on('pagecreate', '#newShopIndex',function(){ 
	getShopNavInfo();
	getShopGoodsInfo();
	//打开弹层
	$('#newShopIndex #bindShopType').on('click',function(){
		$('#newShopIndex #TipBack').show();//遮罩层
		$('#newShopIndex #shopTypeNav').show();
	});
	//关闭弹层
	$('#newShopIndex #cloDiv').on('click',function(){
		$('#newShopIndex #TipBack').hide();//遮罩层
		$('#newShopIndex #shopTypeNav').hide();
	});
	//页面跳转
	$('#newShopIndex #searchShop').on('click',function(){
		var sname = $('#newShopIndex #shopName').val();
		if(sname=='搜索商品')return false;
		changePage('../shop/goodsFinds.html?name='+sname, true);
	});
	
});
 


/**
 * 获取商品数据
 * @param pageNum
 */
function getShopGoodsInfo(){ 
	getAjaxDataWait('/app2/shop/getShopGoodsInfo.jsp', 'goods', function(){
		var lists = goods.lists;
		var specialShop = goods.specialShop;
		//普通商品数据
		if(lists.length>0){
			var html='';
			for(var i=0;i<lists.length;i++){
				var typeName = lists[i].typeName;
				var ls = lists[i].lists;
				var perPrices = lists[i].perPrices;
				var perPrices2 = lists[i].perPrices2;
				var orgNames = lists[i].orgNames;
				var picUrl = lists[i].picUrl;
				var tid = lists[i].tid;
				var perDetailsUrl = lists[i].perDetailsUrl;
				var url = lists[i].isKaoLa ? 'kaoLaGoodsDetails.html?title='+typeName+'&id='+tid :'../shop/allGoodsDetails.html?title='+typeName+'&id='+tid;
				var div ='';
				var html = '<div class="mrcz"><div class="mrcz-wz">-&nbsp;'+typeName+
							'&nbsp;-<span><a href="'+url+'">更多>></a></span></div><div class="ad"><ul>'
							if(ls.length>0){
								for(var j=0;j<ls.length;j++){ 
									var isKaoDiv = '</li></a>';
									if(lists[i].isKaoLa)isKaoDiv='<div class="kltb"><img src="../images/wyklhg.png"></div></li></a>'
								div+='<a href="'+ perDetailsUrl[j]+'">'+
										'<li class="product">'+
										'<img src="'+picUrl[j] +'" alt="product" class="chanpin">'+
										'<h2 class="current">'+ perPrices[j]+'</h2>'+ 
										'<h2>&nbsp;x&nbsp;'+ls[j].stages +'期起</h2>'+									
										'<div class="clearfix"></div>'+
										'<h2 class="yuanjia">'+'<span>'+ perPrices2[j] +'<span>'+'</h2>'+ 
										'<p>'+ tools.formateString(ls[j].name,8)+'</p>'+
										isKaoDiv
								}
								html+=div+'</ul></div></div>'
				}
				$("#newShopIndex #goodsInfo").append(html);
			}
		}
		//特价商品数据展示
		if(specialShop.length>0){
			var html='';
			var selImgNum = 0;
			var html ='<div class="miaosha">-&nbsp;特价商品&nbsp;-</div><div class="ad-lb" id="lunboDiv"><ul id="specialShop" class="ad-ul"></ul></div>'
			$("#newShopIndex #specialGoods").append(html);
			for(var i=0;i<specialShop.length;i++){
				var ls = specialShop[i].lists;
				var prices = specialShop[i].prices;
				var prices2 = specialShop[i].prices2;
				var orgNames = specialShop[i].orgNames;
				var picUrl = specialShop[i].picUrl;
				var perDetailsUrl = specialShop[i].perDetailsUrl;
				var div ='';
				selImgNum +=ls.length;
				if(ls.length>0){
					for(var j=0;j<ls.length;j++){ 
					div+= '<li>'+
							'<a href="'+ perDetailsUrl[j]+'" class="product">'+
							'<img src="'+picUrl[j]+'" alt="product" class="chanpin">'+
							'<h2 class="current">'+ prices[j]+'</h2>'+ 
							'<h2>&nbsp;x&nbsp;'+ls[j].stages +'期起</h2>'+
							'<div class="clearfix"></div>'+
							'<h2 class="yuanjia">¥'+ '<span>'+ prices2[j]+'<span>'+'</h2>'+ 
							'<p>'+ tools.formateString(ls[j].name,8)+'</p>'+
							'</a>'+
							'</li>'
					}
				}
				$("#newShopIndex #specialShop").append(div);
			}
			bannerCarousel($("#newShopIndex .ad-lb"), 1, 3, selImgNum, 100);
		}
		//今日上新
		var todayNewGoods = goods.todayNewGoods;
		if(todayNewGoods.length > 0){
			var todayNewGoodsHtml = '<div class="mrcz-wz">-&nbsp;'+'今日上新'+'&nbsp;-</div><div class="ad"><ul>'
			for(var j=0;j<todayNewGoods.length;j++){ 
				todayNewGoodsHtml += '<a href="'+ todayNewGoods[j].perDetailsUrl+'">'+
										 '<li class="product">'+
										 '<img src="'+todayNewGoods[j].picUrl +'" alt="product" class="chanpin">'+
										 '<h2 class="current">'+ todayNewGoods[j].price+'</h2>'+ 
										 '<h2>&nbsp;x&nbsp;'+todayNewGoods[j].stage +'期起</h2>'+									
										 '<div class="clearfix"></div>'+
										 '<h2 class="yuanjia">¥'+ '<span>'+todayNewGoods[j].price2+'<span>'+'</h2>'+ 
										 '<p>'+ tools.formateString(todayNewGoods[j].name,8)+'</p>'
			}
			todayNewGoodsHtml += '</ul></div>'
			$("#newShopIndex #todayNewGoods").append(todayNewGoodsHtml);
		}
	});
}

/**
 * 给页面弹层添加数据
 * 
 */
function getShopNavInfo(){ 
	getAjaxDataWait('/app2/shop/getShopGoodsTypeInfo.jsp', 'stype', function(){ 
		var ls = stype.shopType;
		if(ls.length>0){
			var html ='';
			for(var i=0;i<ls.length;i++){
				html+='<li><a href="'+ls[i].href+'"><img src="'+ls[i].picUrl+'">'+ls[i].name+'</a></li>'
			}
		}
		$("#newShopIndex #shopType").append(html);
	});
}

/**
 * 获取banner
 * @param id
 * @param type
 */
function getBanner(id,type){
	getAjaxDataWait("/banner/appBanner.jsp?bannerType="+type,"img",function(){
		$("#"+id).children("ul").html("");
		var w = window.innerWidth;
		var w1 = w+"px";
		var list = img.imgs;
		if (list != null && list.length > 0){
	        for(var q = 0; q < list.length; q++){
	        	var banner = '<li data-role="none" style="width: '+w1+'">'
		        					+'<a data-role="none" href="'+list[q].url+'" class="ysjUl" style="width: 100%">'
		        						+'<img  class="ysjUl" style="width: 100%" data-role="none" src='+getBaseRootPath()+list[q].imgUrl+' alt="banner图片">'
		        					+'</a>'
	        					+'</li>';
	        	$("#"+id).children("ul").append(banner);
            }
		}
		$("#"+id).yxMobileSlider({width:w,during:3000});
	});
}

