$(document).on("pageshow", "#shopUpdAddress", function(){
	getShopAddressById();//通过ID获取地址
});
$(document).on("pagecreate", "#shopUpdAddress", function(){
	//关闭弹层
	$("#shopUpdAddress #closeAddressDiv").on("click",function(){
		$("#shopUpdAddress #openDiv").hide();
	});
	//选择省份和地址
//$("#shopUpdAddress #chooseAddress").on("click",function(){
//	 var name=$("#shopUpdAddress #adsName").val();
//	 var phone=$("#shopUpdAddress #adsPhone").val();
//	 var address=$("#shopUpdAddress #adsAddress").val();
//		changePage("shopChoosePro.html?addressId="+getParam("addressId")+"&address="+address+"&phone="+phone+"&name="+name);
//	});
	$("#shopUpdAddress #atpro").on("change",function(){//选择了省
		$("#shopUpdAddress #atcity").html('<option value="0">请选择所在市</option>');
		$("#shopUpdAddress #atdis").html('<option value="0">请选择所在区</option>');
		var nowId = $(this).val();
		if(nowId != 0){
			getCityOrDistById(0, nowId);
		}
	});
	$("#shopUpdAddress #atcity").on("change",function(){//选择了市
		var nowId = $(this).val();
		if(nowId != 0){
			getCityOrDistById(1, nowId);
		}
	});

$("#shopUpdAddress #saveAddress").on("click",function(){
	var name=$("#shopUpdAddress #adsName").val();
	if (name == "" || name == null){
		$("#shopUpdAddress #phoneNum").text("请检查表单,是否存在漏填选项");
		$("#shopUpdAddress #openDiv").show();
		return false;
	}
	var phone=$("#shopUpdAddress #adsPhone").val();
	if (!phone.match(/^(\+\d{2})?(-)*(1[\d]{10})$/i)){
		$("#shopUpdAddress #phoneNum").text("手机号填写有误");
		$("#shopUpdAddress #openDiv").show();
		return false;
	}
	var adsProId =$("#shopUpdAddress #atpro").val();
	var adsCityId =$("#shopUpdAddress #atcity").val();
	var adsDisId =$("#shopUpdAddress #atdis").val();
	if (adsProId ==0 || adsCityId==0 || adsDisId==0){
		$("#shopUpdAddress #phoneNum").text("请检查表单,是否存在漏填选项");
		$("#shopUpdAddress #openDiv").show();
		return false;
	}
	var address = $("#shopUpdAddress #adsAddress").val();
	if (address == null || address == ""){
		$("#shopUpdAddress #phoneNum").text("请检查表单,是否存在漏填选项");
		$("#shopUpdAddress #openDiv").show();
		return false;
	}
	//提交保存该条地址
	var add = encodeURIComponent(address.replace(/&/g,'&amp;').replace('id','&#105;&#100;'));
	getAjaxDataWait("editorAddress.action?name="+name+"&provinceId="+adsProId+"&cityId="+adsCityId+"&distId="+adsDisId+"&phone="+phone+"&address="+  add+"&id="+getParam("addressId"), "addAds", function(){
		showActionTip(addAds, function(){//成功 
			if(newCityId==""||newCityId==null){
				window.history.go(-1); 
			}else{
				window.history.go(-4); 
			}
		}, function(){//失败
			showErrorTip(addAds.data.value, function(){}, 1000);
		});
	});
	
});
});

var oldCityId="";
var newCityId="";
function getShopAddressById(){
	newCityId="";
	//通过ID加载地址信息
	getAjaxDataWait("/app2/shop/shopUpdAddress.jsp?addressId="+getParam("addressId"),"shopAddAds", function(){
		if(shopAddAds.success=="success"){
			var name = getParam("name");
			var phone = getParam("phone");
			var address = getParam("address");
			var proId = getParam("proId");
			var cityId = getParam("cityId");
			if(name!=null){
				$("#shopUpdAddress #adsName").val(name);
			}else{
				$("#shopUpdAddress #adsName").val(shopAddAds.adsName);
			}
			if(phone!=null){
				$("#shopUpdAddress #adsPhone").val(phone);
			}else{
				$("#shopUpdAddress #adsPhone").val(shopAddAds.adsPhone);
			}
			if(address!=null){
				$("#shopUpdAddress #adsAddress").val(address);
			}else{
				$("#shopUpdAddress #adsAddress").val(shopAddAds.adsAddress);
			}
			//省
			var proHtml = '<option value="0">请选择所在省</option>';
			for(var i = 0; i < shopAddAds.proIdList.length; i++){
				proHtml += '<option value="'+shopAddAds.proIdList[i]+'">'+shopAddAds.proNameList[i]+'</option>';
			}
			$("#shopUpdAddress #atpro").html(proHtml);
			var cityHtml = '<option value="0">请选择所在市</option>';
			var distHtml = '<option value="0">请选择所在区</option>';
			if(shopAddAds.distId != 0){ //地区不为0，则显示用户显示的，否则需要重新显示
				//市
				for(i = 0; i < shopAddAds.cityIdList.length; i++){
					cityHtml += '<option value="'+shopAddAds.cityIdList[i]+'">'+shopAddAds.cityNameList[i]+'</option>';
				}
				//区
				for(i = 0; i < shopAddAds.distIdList.length; i++){
					distHtml += '<option value="'+shopAddAds.distIdList[i]+'">'+shopAddAds.distNameList[i]+'</option>';
				}
				$("#shopUpdAddress #atcity").html(cityHtml);
				$("#shopUpdAddress #atdis").html(distHtml);
				$("#shopUpdAddress #atpro").val(shopAddAds.proId);
				$("#shopUpdAddress #atcity").val(shopAddAds.cityId);
				$("#shopUpdAddress #atdis").val(shopAddAds.distId);
			}else{
				$("#shopUpdAddress #atcity").html(cityHtml);
				$("#shopUpdAddress #atdis").html(distHtml);
			}
		}
	
});
}
/**
 * 通过用户选择的option，获取下一级列表
 */
function getCityOrDistById(state, nowId){
	getAjaxDataWait("/app2/shop/getAddressCityDist.jsp?state="+state+"&id="+nowId,"addressData", function(){
		if(addressData.success=="success"){
			var cityHtml = '<option value="0">请选择所在市</option>';
			var distHtml = '<option value="0">请选择所在区</option>';
			var cityStatus = false;
			if(state == 0){
				cityStatus = true;
			}
			for(var i = 0; i < addressData.idList.length; i++){
				if(state == 0){ //获取市
					cityHtml += '<option value="'+addressData.idList[i]+'">'+addressData.nameList[i]+'</option>';
				}else{ //获取区
					distHtml += '<option value="'+addressData.idList[i]+'">'+addressData.nameList[i]+'</option>';
				}
			}
			if(cityStatus){
				$("#shopUpdAddress #atcity").html(cityHtml);
			}else{
				$("#shopUpdAddress #atdis").html(distHtml);
			}
		}
	});
}
