/**
 * searchDes.html js 
 *	getAjaxDataWait('app2/.jsp','obj',function(){});
 *	getAjaxData('app2/.jsp','obj',function(){});
 */
$(document).on('pageshow','#searchDes',function(){
	var hisBox = se$('.paddingMain'); //显示搜索历史的区域
	hisBox.html(writeDesHistory());
});

 $(document).on('pagecreate','#searchDes',function(){
	 var showBox = se$('.content em'); //显示出发地
	 var searIpt  = se$('.eduSearchInput'); //搜索框
	 var LINK = se$('[id ^= "link_"]'); //显示查询链接
	 
	 var des = window.des;
	 initLinks();
	 
	 searIpt.on('blur', function(){
		 des = $(this).val().trim();
		 if(des.length > 2){
			 showBox.val(des);
		 }
		 initLinks(des);
	 }).val(des);
	 
	 showBox.each(function(i){
		 $(this).html(des);
	 });
	 LINK.each(function(){ //点击搜索链接
		 var id = this.id.split('_')[1];
		 $(this).on('click',function(){
			 des = searIpt.val().trim();
			 storageUtil.saveDesHistory(des); //设置搜索历史
			 window.lineProperty = id;
			 history.go(-1); //回到列标页
		 });
	 });
	 
	 $(document).delegate('#searchDes .paddingMain>ul>li>a','click',function(){//点击搜索历史按钮
		 var ON = 'courseScreenBtn';
		 if($(this).prop('class').indexOf(ON) > -1){return false;}
		 var des = $(this).html();
		 $(this).removeClass().addClass(ON).parent().siblings().children().removeClass();
		 searIpt.val(des);
		 initLinks();
	 });
	 
 });
 
 /**
  * 当前页面选择器
  * @param selector
  * @returns
  */
 function se$(selector){
	 return $('#searchDes ' + selector);
 }
 
 
 /**
 * 初始化链接
 */
function initLinks(des){
	 des = des || se$('.eduSearchInput').val();
	 if(!des || des == ''){
		 se$('[id ^= "link_"]').hide();
	 } else {
		 se$('.content em').html(des);
		 se$('[id ^= "link_"]').show();
	 }
	 window.des = des;
 }

/**
 * 写入搜索历史
 * @returns
 */
function writeDesHistory(){ //courseScreenBtn
	var html = '<p class="courseScreen">历史搜索记录：</p> <ul class="screenList">';
	var hist = storageUtil.getDesHistory();
	for(var i=0; i < hist.length; i++){
		var st = (i +1)%3 == 0 ? 'margin-right:0px;' : '';
		html += '<li><a href="javascript:void(0)" style=" ' + st + '" >' + hist[i] + '</a></li>';
	}
	html += '</ul>';
	return html.indexOf('<li>') > -1 ? html : '';
}