$(document).on("pagecreate", "#customBiaoRecord_page", function(){
	$("[id^='customBiaoRecord_more_']").on("click", function(){
		var nextPageNum = $(this).get(0).id.split("_")[2];
		customBiaoRecordTurnPage(nextPageNum, bid, false);
	});
});
$(document).on("pageshow", "#customBiaoRecord_page", function(){
	var bid = getParam("bid");
	customBiaoRecordTurnPage(0, bid, true);
});
function customBiaoRecordTurnPage(pageNum, bid, cxm){
	var cx = cxm || true;
	var pn = pageNum || 0;
	getAjaxDataWait("/app2/custom/customBiaoRecord.jsp?pageNum=" + pn + "&bid=" + bid, "biaoAndCbrList", function(){
		var crbList = biaoAndCbrList.list;// 投标记录
		var maxPage = biaoAndCbrList.maxPageNum;
		var nextPage = biaoAndCbrList.nextPage;
		if (crbList != null && crbList.length > 0){
			if (nextPage >= maxPage){// 数据不足三十条 或者 是最大页数
				if (!$("[id^='customBiaoRecord_more_']").is(':hidden')){
					$("[id^='customBiaoRecord_more_']").attr({
						id : "customBiaoRecord_more_0"
					});// 修改页码
					$("[id^='customBiaoRecord_more_']").hide();
				}
			}else{
				if ($("[id^='customBiaoRecord_more_']").is(':hidden')){
					$("[id^='customBiaoRecord_more_']").show();
				}
				$("[id^='customBiaoRecord_more_']").attr({
					id : "customBiaoRecord_more_" + nextPage
				});// 修改下一页页码
			}
			for(var i = 0; i < crbList.length; i++){
				$("#customBiaoRecord_tbody").append("<tr><td>" + crbList[i].title + "</td><td>" + crbList[i].money + "</td></tr>")
			}
		}
		if (cx){// 加载更多不刷新标数据
			$("#customBiaoRecord_title").html(biaoAndCbrList.title);
			$("#customBiaoRecord_jd").css({
				width : biaoAndCbrList.jd + "%"
			});
			$("#customBiaoRecord_yearRate").html(biaoAndCbrList.yearRate + "<i>%</i>");
			$("#customBiaoRecord_biaoMonth").html(biaoAndCbrList.biaoMonth + "<i>个月</i>");
			$("#customBiaoRecord_fullMoney").html(biaoAndCbrList.fullMoney + "<i>元</i>");
		}
	});
}