var storageUtil={
	isCreateLazy:function(v){
		//不传值，表查询。传值表设置
		if(v===undefined){
			var o=storageUtil.loadLocalStroage("isCreateLazy");
			return o===true;
		}else{
			storageUtil.saveLocalStorage("isCreateLazy",v);
		}
	},
	isWelcome:function(v){
		if(v===undefined){
			var o=storageUtil.loadLocalStroage("welcomePage");
			return o===true;
		}else{
			storageUtil.saveLocalStorage("welcomePage",v);
		}
	},
	setSessionId:function(sessionId){
		if(!tools.isRealNull(sessionId)){
			if(sessionId=="-"){
				sessionId="";
			}
			storageUtil.saveLocalStorage("sessionId",sessionId);
		}
	},
	getSessionId:function(sessionId){
		var sid = storageUtil.loadLocalStroage("sessionId");
		if(sid=='-'){
			return "";
		}
		return sid;
	},
	isLUser:function(){
		var v=storageUtil.getLUser();
		return v!=null&&v.password!=null&&v.password.length>6;
	},
	getLUser:function(){
		return storageUtil.loadLocalStroage("LUser");
	},
	getLHead:function(){
		var head=wwwBasePath+"images/default_user_headimg.jpg";
		if(storageUtil.isLUser()){
			var h=storageUtil.getLUser().head;
			if(h!=null&&h.length>25){
				if(h.indexOf('/')==0){
					h=h.substring(1);
				}
				head = getBaseRootPath()+h;
			}
		}
		return head;
	},
	setLUser:function(o){
		storageUtil.saveLocalStorage("LUser",o);
	},
	exitLUser:function(){
		var v=storageUtil.getLUser();
		if(v!=null){
			v.password="";
			storageUtil.setLUser(v);
		}
		storageUtil.setSessionId("");
	},
	saveIndexPics:function(o){
		storageUtil.saveLocalStorage("IndexPics",o);
	},
	getIndexPics:function(){
		return storageUtil.loadLocalStroage("IndexPics");
	},
	saveDefBankId:function(id){
		if(storageUtil.getLUser().username){
			storageUtil.saveLocalStorage(storageUtil.getLUser().username+"_defBankid",id);
		}
	},
	getDefBankId:function(){
		if(storageUtil.getLUser().username){
			return storageUtil.loadLocalStroage(storageUtil.getLUser().username+"_defBankid")||-1;
		}
		return -1
	},
	saveDemand178bid:function(bid){//保存已索要过邀请码的bid
		if(storageUtil.getLUser().username){
			var dbid = storageUtil.getDemand178bid();
			dbid.push(bid);
			storageUtil.saveLocalStorage(storageUtil.getLUser().username+"_demand178bid",dbid);
		}
	},
	getDemand178bid:function(){//获取所有保存的已索要过的邀请码
		if(storageUtil.getLUser().username){
			var dbid = storageUtil.loadLocalStroage(storageUtil.getLUser().username+"_demand178bid");
			return dbid || new Array();
		}
		return null;
	},
	isDemand178bid:function(bid){//判断该bid是否索要过,true索要过 false未索要过
		if(storageUtil.getLUser() && storageUtil.getLUser().username){
			var dbid = storageUtil.getDemand178bid();
			return dbid.indexOf(bid)>-1;
		}
		return false;
	},
	saveDesHistory:function(des){ //保存旅游【目的地】搜索历史
		var hist = storageUtil.getDesHistory();
		if($.inArray(des,hist) > -1 || des == '' || !des){ return; }
		if(hist.length > 5){ hist.pop(); }
		hist.unshift(des);
		storageUtil.saveLocalStorage("travelSearchDesHist",hist);
	},
	getDesHistory:function(){ //获取旅游【目的地】搜索历史
		var hist = storageUtil.loadLocalStroage("travelSearchDesHist");
		return hist || new Array();
	},
	removeDesHistory:function(){ //清空【目的地】搜索历史
		storageUtil.removeLocalStroage("travelSearchDesHist");
	},
	saveDepHistory:function(dep){ //保存【出发地】的地搜索历史
		var hist = storageUtil.getDepHistory();
		if($.inArray(dep,hist) > -1 || dep == '' || !dep){ return; }
		if(hist.length > 5){ hist.pop(); }
		hist.unshift(dep);
		storageUtil.saveLocalStorage("travelSearchDepHist",hist);
	},
	getDepHistory:function(){ //获取旅游【出发地】搜索历史
		var hist = storageUtil.loadLocalStroage("travelSearchDepHist");
		return hist || new Array();
	},
	removeDepHistory:function(){ //清空【出发地】搜索历史
		storageUtil.removeLocalStroage("travelSearchDepHist");
	},
	saveLocalStorage:function(k,v){
		if(v==null||v.length<1){
			storageUtil.removeLocalStroage(k);
		}else{
			localStorage.setItem(k,JSON.stringify(v))
		}
	},
	loadLocalStroage:function(k){
		var v=localStorage.getItem(k);
		if(v==null||v.length<1)return null;
		try {
			return JSON.parse(v);
		} catch (e) {
			storageUtil.removeLocalStroage(k);
			return null;
		}
	},
	removeLocalStroage:function(k){
		localStorage.removeItem(k)
	}
}

function __PhoneGapDB(){
	this.obj=this;
	//'Database'数据库的名称 '1.0'数据库的版本号 'PhoneGap Demo'数据库的显示名。'200000'以字节为单位的数据库大小。
	this.db = window.openDatabase("Database", "1.0", "PhoneGap Demo", 200000);//window.openDatabase返回一个新的Database对象。
	// 事务执行出错后调用的回调函数 
	this.error=function(tx, err) { 
		alert("Error processing SQL: "+err); 
	};
	// 事务执行成功后调用的回调函数 
	this.success=function(){ 
		alert("success!"); 
	};
	//执行sql或者一个方法
	this.exec=function(sql,succ,err){
		/*sql=function(tx){ 
			tx.executeSql('DROP TABLE DEMO IF EXISTS'); 
			tx.executeSql('CREATE TABLE IF NOT EXISTS DEMO (id unique, data)'); 
			tx.executeSql('INSERT INTO DEMO (id, data) VALUES (1, "First row")'); 
			tx.executeSql('INSERT INTO DEMO (id, data) VALUES (2, "Second row")'); 
		}*/
		var obj ;
		if(typeof(sql)=='string'){
			obj = function(tx){
				tx.executeSql(sql); 
			}
		}else{
			obj=sql;
		}
		db.transaction(obj,err||this.error,succ||this.success);//运行一个数据库事务。
	}
}
//等待加载PhoneGap 
//document.addEventListener("deviceready",function(){window.phoneDb=new __PhoneGapDB();}, false);