$(document).on("pagecreate","#buyInsure",function(){
	$("#buyInsure #buyNow").css("cursor","default");
	getAjaxDataWait("app2/insure/buyInsure.jsp", "getInsure", function(){
		var insFlag = getInsure.insureFlag;
		var aVal = insFlag ? "立即追加" : "立即投保";
		var action = insFlag ? "buyInsureP_app" : "buyInsureB_app";
		$("#buyInsure #noInsure").text(getInsure.noInsure);
		$("#buyInsure #safeDate").html(insFlag ? '<em class="money_num mean_color"></em>'+getInsure.safeTerm : '<em class="money_num mean_color">1</em>&nbsp;年(自投保72小时起一年)');
		$("#buyInsure #buyNow").text(aVal);
		var messIns = '';
		var insures = getInsure.insures;
		var coverage = getInsure.coverage;
		for(var i=0;i<insures.length;i++){
			var insureCss = i+1 == insures.length ? "pay_success" : "";
			messIns +=
				'<li>'+
					'<a href="javascript:void(0);" class="buy_insure" id=insure_'+insures[i].id+'>'+
						'<div class="mycenter_list_rightline">'+
                       '<span id=premium_'+insures[i].id+'>保费：<em>￥</em>'+getInsure.premiums[i]+'</span>'+
                       '<span>保额：￥<em>'+coverage[i]+'</span>'+
                    '</div>'+
                    '<em class="'+insureCss+'" id="em_'+insures[i].id+'"></em>'+
                '</a>'+
              '</li>';
		}
		$("#buyInsure #showInsure").html(messIns);
		
		//点击选择保险
		var idVal = $("#buyInsure li a.buy_insure em.pay_success").attr("id").split("_")[1];
		var preMoney = $("#buyInsure #premium_"+idVal).text().split("￥")[1];
		$("#buyInsure [id ^= 'insure_']").on("click",function(){
			idVal = this.id.split("_")[1];
			preMoney = $("#buyInsure #premium_"+idVal).text().split("￥")[1];
			$("#buyInsure [id ^= 'em_']").removeClass("pay_success");
			$("#buyInsure #em_"+idVal).addClass("pay_success");
		});
		
		//点击立即投保/立即追加
		$("#buyInsure #buyNow").on("click",function(){
			if(!$("#buyInsure [id ^= 'em_']").hasClass("pay_success")){
				$.alert("请选择购买的保险");
				return false;
			}
			if(!$("#buyInsure #buyNow").hasClass("button_ab")){
				if(idVal < 1){
					$.alert("保险信息异常，请重试");
					return false;
				}
				if(getInsure.oddNumNull || getInsure.isType || getInsure.isDate){
					$.alert("上次购买账户安全险尚未生效，生效后方可重复购买");
					return false;
				}
				/*if(getInsure.noInsure - preMoney < 0){
					$.alert("包余额不足");
					return false;
				}*/
				changePage("../user/pay.html?inid="+idVal+"&orderMoney="+preMoney+"&cbPage="+action,{"login":"true"});
			}
		});
		
		//债权转让协议改变样式
		var num = 1;
		$("#buyInsure #insPro").on("click",function(){
			if(num % 2 == 1){
				$(this).removeClass(" lqcheckb");
				$("#buyInsure #buyNow").addClass("button_ab");
				$("#buyInsure #buyNow").css("cursor","default");
			}else{
				$(this).addClass(" lqcheckb");
				$("#buyInsure #buyNow").removeClass("button_ab");
				$("#buyInsure #buyNow").css("cursor","pointer");
			}
			num++;
		});
		
		var CLAUSE = $('#buyInsure .user_insure_hint'); //点击跳转到条款详细
		CLAUSE.on('click',function(){
			//changePage('insureClause.html');
			showExplain($.mobile.activePage.prop("id"));
		});
	});
});