$(document).on('pageshow','#shopPage',function(){
	 //获取全部商品类别
	getShopPageInit();
	addRedPoint('shopPage .friends'); // 获取人脉小红点
	//判断底部是否有样式，有就拿掉
	var qb = $("#shopPage #shopGo_qb").hasClass("solid");
	var rm = $("#shopPage #shopGo_rm").hasClass("solid");
	var wd = $("#shopPage #shopGo_wd").hasClass("solid");
	if(qb || rm || wd){
		$("#shopPage [id ^= 'shopGo_']").removeClass("solid");
	}
	$("#shopPage #tipDiv").hide();//初始隐藏小提示
});
function getShopPageInit(pageNum){
	pageNum = pageNum || 0; 
	getAjaxDataWait("/app2/shop/shopPage.jsp?pageNum="+ pageNum, "shopList", function(){
		 var list = shopList.list;
		 if(list.length>0){
			 var html ='';
			 for(var i=0;i<list.length;i++){
				html ='<a href="../shop/allGoodsDetails.html?id='+list[i].id+'&title='+list[i].typeName +'">'+
					  '<div class="t_banner2">'+
					  '<img src="'+ getBaseRootPath() + shopList.pic[i] +'"/>'+
					  '</div></a>'
					  $("#shopPage #div_shopList").append(html);
			 }
			 if (shopList.nextPageNum != null && shopList.nextPageNum != pageNum){
				 $("#shopPage #div_shopList").append(createLazyLoading("getShopPageInit(" + shopList.nextPageNum + ")"));
			 }
		 }
	 });
}
$(document).on('pagecreate', '#shopPage',function(){
	//点击切换乾包--人脉--我的
	$("#shopPage [id ^= 'shopGo_']").on("click", function(){
		var isHave = $(this).hasClass("solid");
		if(isHave){
			if(this.id == "shopGo_qb"){
				changePage("../ind.html");				
			}else if(this.id == "shopGo_rm"){
				changePage("../contacts/index2.html", { "login" : "true" });
			}else if(this.id == "shopGo_wd"){
				changePage("../mine/mineIndex.html", { "login" : "true" });
			}
		}else {
			$("#shopPage [id ^= 'shopGo_']").removeClass("solid");
			$(this).addClass("solid");
			if(this.id == "shopGo_qb"){
				changePage("../ind.html");				
			}else if(this.id == "shopGo_rm"){
				changePage("../contacts/index2.html", { "login" : "true" });
			}else if(this.id == "shopGo_wd"){
				changePage("../mine/mineIndex.html", { "login" : "true" });
			}
		}
	});
	//--------------------------点击切换---------------------------
	/*$("#shopPage [id ^= 'tit_']").on("click", function(){
		var whichDiv = this.id.split("_")[1];
		$("#shopPage [id ^= 'div_']").hide();
		$("#shopPage [id ^= 'footer_']").hide();
		$("#shopPage [id ^= 'div_"+whichDiv+"']").show();
		$("#shopPage [id ^= 'footer_"+whichDiv+"']").show();
		if(whichDiv == "surveyShoppingIntention"){//如果是外链购物就有那个小提示的按钮
			//判断是否登录
			changePage("shopPage.html", { "login" : "true" });
			$("#shopPage #tipDiv").show();
		}else{
			$("#shopPage #tipDiv").hide();
		}
	});*/
	$("#shopPage #tit_surveyShoppingIntention").on("click", function(){//外链购物
		if(!storageUtil.getLUser()){
			changePage("../login.html");
			return false;
		}
		$("#shopPage #div_shopList").hide();
		$("#shopPage #footer_shopList").hide();
		$("#shopPage #div_surveyShoppingIntention").show();
		$("#shopPage #footer_surveyShoppingIntention").show();
		$("#shopPage #tipDiv").show();
	});
	$("#shopPage #tit_shopList").on("click", function(){//商品分类
		$("#shopPage #div_surveyShoppingIntention").hide();
		$("#shopPage #footer_surveyShoppingIntention").hide();
		$("#shopPage #div_shopList").show();
		$("#shopPage #footer_shopList").show();
		$("#shopPage #tipDiv").hide();
	});
	//提交购物链接
	$("#shopPage #subIntention").on("click", function(){
		if($(this).hasClass("shop-pay-button")){
			var url = $("#shopPage #intention_url").val();
			var mem = $("#shopPage #intention_mem").val();
			//判断url字符长度
			var urlLen = parseInt(url.length);
			//判断mem字符长度
			var memLen = parseInt(mem.length);
			if(urlLen > 300){
				$.alert("复制的链接长度过长");
				return false;
			}
			if(!valid.isMoney($("#shopPage #intention_priceBefore").val())){
				$.alert("金额不正确");
				return false;
			}
			if(memLen > 100){
				$.alert("备注长度过长");
				return false;
			}
			var price =  parseInt($("#shopPage #intention_priceBefore").val() * 100);
			var encodeUrl = encodeURIComponent(url.replace(/&/g,'&amp;').replace('id','&#105;&#100;'));
			var encodeMem = encodeURIComponent(mem.replace(/&/g,'&amp;').replace('id','&#105;&#100;'));
			getAjaxDataWait("InsertChainPurchase.action?url="+ encodeUrl +"&mem=" + encodeMem + "&price=" + price, "res", function(){
				 showActionTip(res, function(){
					 $("#shopPage #intention_url").val("");
					 $("#shopPage #intention_mem").val("");
					 $("#shopPage #intention_priceBefore").val("")
		        	}, function(){
		        		showErrorTip(res.data.value);
		        	});
			 });
		}
	});
	//判断提交按钮的颜色
	$("#shopPage [id ^= 'intention_']").on("change", function(){
		var url = $("#shopPage #intention_url").val();
		var mem = $("#shopPage #intention_mem").val();
		var priceBefore = $("#shopPage #intention_priceBefore").val();
		if(!url || !mem || !priceBefore){
			$("#shopPage #subIntention").removeClass("shop-pay-button");//蓝色
			$("#shopPage #subIntention").addClass("survey-buttono");//灰色
		}else{
			$("#shopPage #subIntention").removeClass("survey-buttono");
			$("#shopPage #subIntention").addClass("shop-pay-button");
		}
	});
	//点击右上角小提示
	$("#shopPage #tip").on('click',function(){//显示弹层
		showExplain($.mobile.activePage.prop("id"));
	});
});