$(document).on('pagecreate','#reg', function(){
	setArea('',function(o){
		$("#reg #provinceR").val(o.province);
		$("#reg #cityR").val(o.city);
	});
	$("#reg #showAgree").on("click",function(){//显示协议
		changePage('regAgreement.html');
	});
	var username = "";
	var mobile = "";
	var password = "";
	var chAgreement = "";
	$("#reg #head").change(function(){//校验上传的头像
		if($("#reg #head").val() != ""){
			if(!valid.isCheckPic(this,15360));
		}
	});
	$("#reg #mobile").keyup(function(){ //正整数输入限制 
		this.value = this.value.replace(/\D/g,'');
	});
	$("#reg #subNext").on("click",function(){// 点击下一步
		username = $("#reg #username").val().trim();
		if(username == '' || username == null){
			$.alert("请输入用户名");
			return false;
		}
		if(/^[0-9]*$/.test(username)){
			$.alert("用户名不能为纯数字");
			return false;
		}
		if(!valid.isUserName(username) || username.replace(/[\u4e00-\u9fa5]/g,"**").length < 6 || username.replace(/[\u4e00-\u9fa5]/g,"**").length > 16){
			$.alert("用户名由6~16位字符组成,由字母数字中文下划线组成");
			return false;
		}
		if(!checkUsername(username)){
			$.alert("用户名已经存在");
			return false;
		}
		mobile = $("#reg #mobile").val();
		if(mobile == '' || mobile == null){
			$.alert("请输入11位手机号码");
			return false;
		}
		if(!valid.isPhone(mobile)){
			$.alert("请输入正确的手机号");
			return false;
		}
		if(!checkMobile(mobile)){
			$.alert("手机号已被使用");
			return false;
		}
		qq = $("#reg #qq").val().trim();
		if(qq==''||qq==null){
			$.alert("请输入QQ号码");
			return false;
		}
		if(qq.replace(/[^\d]/g,'').length==0||qq.replace(/[^\d]/g,'').length<5||qq.replace(/[^\d]/g,'').length>16){
			$.alert("请输入正确的QQ号码");
			return false;
		}
		password = $("#password").val();
		if(password == '' || password == null){
			$.alert("请输入您的登录密码");
			return false;
		}
		if(password.length < 6 || password.length > 12){
			$.alert("密码由请输入6~12个字符组成");
			return false;
		}
		var classStr = $("#reg #img_").attr("class");
		if(classStr.indexOf("lqcheckb") <= -1){
			$.alert("请阅读并同意《乾包协议》");
			return false;
		}else{
			chAgreement = "chArgeementOk";//同意协议赋值
		}
		$("#reg #regeMain1").hide();
		$("#reg #regeMain2").show();
	});
	$("#reg #fromPhoto").on("click",function(){//从相册选择
		filePlug({flag:1,viewImg:'headImg_',action:'http'+'://'+getBasePath()+'UpdateLoadHead.action?fileType=customer',beforUpload:function(){$('#cancel').click()}});
	});
	$("#reg #photograph").on("click",function(){//拍照
		filePlug({flag:0,viewImg:'headImg_',action:'http'+'://'+getBasePath()+'UpdateLoadHead.action?fileType=customer',beforUpload:function(){$('#cancel').click()}})
	});
	$("#reg #showHead").on("click",function(){//选择头像弹层
		$("#showInDi").show();
		$("#hideDiv").show();
	});
	$("#reg #cancel").on("click",function(){//取消头像弹层
		$("#showInDi").hide();
		$("#hideDiv").hide();
	});
	$("#reg #subR_").on("click",function(){// 加入乾包
		var validcode = $("#reg #validcode").val();//验证码
		if(validcode == '' || validcode == null){
			$.alert("请输入收到的6位验证码");
			return false;
		}
		var province = $("#reg #provinceR").val();
		var city = $("#reg #cityR").val();
		getAjaxDataWait("UserRegisterApp.action?username=" + username + "&mobile=" + mobile +"&qq="+qq+ "&chSMS=" + validcode + "&password=" + password + "&url=asdfg" + "&chAgreement=" + chAgreement + "&province=" + province + "&city=" + city + "&validcode=2016","reg", function(){
			if(reg.suc == "操作成功"){
				storageUtil.setLUser(reg.logUser);
				$.alert(reg.suc,function(){
					changePage("../user/regSuccess.html");//新用户注册提示页
				},"","确定");
			}else{
				$.alert(reg.data.value);
			}
		});
	});
	$("#reg #gain").on("click",function(){//获取验证码
		getAjaxDataWait("ajax/sms.jsp?type=1&tel=" + mobile,"validcode", function(){
			if(validcode == '验证码发送成功，请注意查收'){
				$.alert(validcode);
				$("#reg #gain").hide();
				$("#reg #reSend").show();
				getSMS();
			}else{
				$.alert(validcode);
				return false;
			}
		});
	});
	var num = 1;
	$("#reg #img_").on("click",function(){//协议改变样式
		if(num % 2 == 0){
			$(this).addClass(" lqcheckb");
		}else{
			$(this).removeClass(" lqcheckb");
		}
		num++;
	});
	
	//跳转到乾包协议界面
	$("#reg #showAgree").on("click",function(){
		changePage("regAgreement.html");
	});
	//跳转到无息分呗协议界面
	$("#reg #showAgree_").on("click",function(){
		changePage("dividedMent.html");
	});
});
function checkUsername(username){//校验用户名是否可用
	var checkNum = 0;
	getAjaxData("app2/user/validUserName.jsp?username=" + username, "validu", function(){
		if(validu.validu == 1){
			checkNum = 1;
		}
	});
	return checkNum == 0;
}
function checkMobile(mobile){//校验手机号是否可用
	var checkNum = 0;
	getAjaxData("app2/user/validUserName.jsp?mobile=" + mobile, "validm", function(){
		if(validm.validm == 1){
			checkNum = 1;
		}
	});
	return checkNum == 0;
}
function getSMS(){//时间递减
	var time = 60;
	var timeRess = setInterval(function(){
		time = time - 1;
		if(parseInt(time) >= 0){
			$("#reg #reSend").html("重新发送(" + parseInt(time) + "s)");
		}else{
			$("#reg #reSend").html("重新发送(59s)");
			$("#reg #reSend").hide();
			$("#reg #gain").show();
			clearInterval(timeRess);
		}
	}, 1000);
}