cordova.define("org.apache.cordova.baofu", function(require, exports, module) {

	var exec = require('cordova/exec');

	module.exports = {

		/**
		 * 一共5个参数 第一个 :成功会掉 第二个 :失败回调 第三个 :将要调用的类的配置名字(在config.xml中配置 稍后在下面会讲解)
		 * 第四个 :调用的方法名(一个类里可能有多个方法 靠这个参数区分) 第五个 :传递的参数 以json的格式
		 */
		pay : function(mills,fun) {
			exec(function(winParam) {
				//alert(winParam);
				//$("#result1").html(winParam);
				window.isPlug=true;
				fun(winParam);
			}, null, "Plugin_pay", "intent", mills);
		},
	};

});

var MyIOSPlugin = {
		//cordova plugin add https://github.com/xu-li/cordova-plugin-wechat --variable wechatappid=wx3e508a6e5f8b2cc9
		wxTIMELINE:function(title,content,picUrl,webUrl){
			Wechat.share({
				message: {
					title: title,//"分享",
					description: content,//"描述",
					mediaTagName: "乾包分享",
					thumb: picUrl,//"http://www.qb178.com/images/logo_03.jpg",
					media: {
						type: Wechat.Type.WEBPAGE, //类型是一个webpage，就是一个网页？
						webpageUrl: webUrl//"http://www.qb178.com/"
					}
				},
				scene: Wechat.Scene.TIMELINE   // 分享到朋友圈
			},function(){/*alert('success')*/},function(v){alert('error:'+v)});
		},
		checkAppVersion:function(paramenter,success,fail){
			var exec = cordova.require("cordova/exec");
			exec(success, fail, "Plugin_version", "isUpdate", []);
		},
		wxSESSION:function(title,content,picUrl,webUrl){
			Wechat.share({
				message: {
					title: title,//"分享",
					description: content,//"描述",
					mediaTagName: "乾包分享",
					thumb: picUrl,//"http://www.qb178.com/images/logo_03.jpg",
					media: {
						type: Wechat.Type.WEBPAGE, //类型是一个webpage，就是一个网页？
						webpageUrl: webUrl//"http://www.qb178.com/"
					}
				},
				scene: Wechat.Scene.SESSION   // 分享到好友
			},function(){/*alert('success')*/},function(v){alert('error:'+v)});
		},
		scan:function() {
			cordova.plugins.barcodeScanner.scan(function(result) {
				if (result.cancelled){
					//$.alert("用户取消扫描");
				}else{
					var txt = result.text;
					//alert(txt);
					if(txt.match(/^qb_\d+_.*$/ig)){
						var txts = txt.split("_");
						if(txts.length<3){
							$.alert("二维码异常，请重试");
						}else{
							switch(txts[1]){
							case "1"://投178标
								if(txts.length<4){
									$.alert("二维码异常，请重试");
								}else{
									changePage("package178/pack178BiaoInfo.html?id="+txts[2]+"&onlyKey="+txts[3],{'login':'true'});
								}
								break;
							case "3"://机构课程列表
								window.qrcodeOid=txts[2];
								changePage("sweep/sweepResults.html");
								break;
							}
						}
					}else{
						$.alert(txt,null,"扫描结果")
					}
				}
			}, function(error) {
				$.alert("扫码失败："+error);
			});
		},
		scanImg:function(imgURI) {
			cordova.plugins.barcodeScanner.scanImg(function(result) {
				var txt = result;
				if(txt.match(/^qb_\d+_.*$/ig)){
					var txts = txt.split("_");
					if(txts.length<3){
						$.alert("二维码异常，请重试");
					}else{
						switch(txts[1]){
						case "1"://投178标
							if(txts.length<4){
								$.alert("二维码异常，请重试");
							}else{
								changePage("package178/pack178BiaoInfo.html?id="+txts[2]+"&onlyKey="+txts[3],{'login':'true'});
							}
							break;
						case "3"://机构课程列表
							window.qrcodeOid=txts[2];
							changePage("sweep/sweepResults.html");
							break;
						}
					}
				}else{
					$.alert(txt,null,"扫描结果")
				}
			}, function(error) {
				$.alert("扫码失败："+error);
			},imgURI);
		},
		encode:function(val) {
			val = val||'https://www.qb178.com/';
	 		cordova.plugins.barcodeScanner.encode("TEXT_TYPE",val,function(result) {
	 			if (result.cancelled){
					//$.alert("用户取消扫描");
				}else{
					//$.alert("扫描结果: " + result.text)
				}
	 		}, function(error) {
	 			$.alert("二维码错误请重试");
	 		});
		}
}